#include "Schuh.h"
#include "Spieler.h"

SchuhEffect::SchuhEffect( ResourceRegistry *zResources, Spieler *zSpieler )
    : Effect( zSpieler, 20.f + ( 20.f / 100.f ) * zSpieler->getAbklingZeitVerringerung() )
{
    speedup = 15;
    zSpieler->setLaufTempo( zSpieler->getLaufTempo() + speedup );
    bild = zResources->zResource( R_SCHUH, 0 )->getImage( 0 );
    effectImage = zResources->zResource( R_SCHUH, 0 )->getImage( 0 );
}

SchuhEffect::~SchuhEffect()
{
    zSpieler->setLaufTempo( zSpieler->getLaufTempo() - speedup );
    bild->release();
}

bool SchuhEffect::tick( double time, Spiel *zSpiel )
{
    zSpieler->setLaufTempo( zSpieler->getLaufTempo() - ( (float)time / timeLeft ) * speedup );
    speedup -= ( (float)time / timeLeft ) * speedup;
    return Effect::tick( time, zSpiel );
}

void SchuhEffect::renderSpieler( Bild &rObj )
{
    if( rObj.setDrawOptions( (int)zSpieler->getX(), (int)zSpieler->getY(), (int)zSpieler->getWidth(), (int)zSpieler->getHeight() ) )
    {
        rObj.alphaBildSkall( 0, (int)zSpieler->getHeight() / 3, (int)zSpieler->getWidth(), (int)zSpieler->getHeight() / 3 * 2, *bild );
        rObj.releaseDrawOptions();
    }
}